c---- constants
      integer   maxrefl         ! Maximum number of reflections
      parameter (maxrefl=400000)
      integer   maxfaces        ! Maximum number of faces
      parameter (maxfaces=100)
      integer   maxparam        ! Maximum number of parameters
      parameter (maxparam=maxfaces)
      integer   maxcorners      ! Maximum number of corners
      parameter (maxcorners=500)
      integer   maxmodes        ! Nr of projection modes
      parameter (maxmodes=4)
      integer   maxedges        ! Maximum number of edges
      parameter (maxedges=maxcorners/2)
      integer   maxrotaxes      ! Maximum number of rotaxes
      parameter (maxrotaxes=1000)
      integer   maxmatrices     ! Maximum number of matrices in OrientationList
      parameter (maxmatrices=10000)
      integer   maxDeltaTilt    ! Maximum miller index change
      parameter (maxDeltaTilt=2)
      integer   maxSphere       ! Number of Sphere Models
      parameter (maxSphere=7)
      integer   maxCube         ! Number of Cube models
      parameter (maxCube=5)
c===============================================================
c---- daughter data
      integer   nref            ! number of reflections
c---- daughter pointers to integer data
      integer   pDh             ! miller index
      integer   pDk             ! miller index
      integer   pDl             ! miller index
      integer   pDbatch         ! batch number
      integer   pDactive        ! used to squish reflections
      integer   pDsister        ! pointer to next reflection
      integer   pDIMAX          ! maximum integer pointer
      parameter (pDh=1)
      parameter (pDk=2)
      parameter (pDl=3)
      parameter (pDbatch=pDl+1)
      parameter (pDactive=pDbatch+1)
      parameter (pDsister=pDactive+1)
      parameter (pDImax=pDsister)
      integer   dI(pDIMAX,MaxRefl) ! daughter integer data
c---- daughter pointers to real data
      integer   pDintensity     ! intensity
      integer   pDsigma         ! sigma
      integer   pDcosinesF      ! first direction cosine
      integer   pDcosinesL      ! last direction cosine
      integer   pDRMAX          ! maximum real pointer
      parameter (pDintensity=1)
      parameter (pDsigma=pDintensity+1)
      parameter (pDcosinesF=pDsigma+1)
      parameter (pDcosinesL=pDcosinesF+5)
      parameter (pDRmax=pDcosinesL)
      real      dR(pDRMAX,MaxRefl) ! daughter real data
      common /facelift_daughter/ nref,dI,dR
c===================================================================
c---- mother data
      integer   HASHBINS
      parameter (HASHBINS=73)
      integer   MAXMOTHER
      parameter (MAXMOTHER=200000/HASHBINS)
      integer   Nunique
      integer   nmother(hashbins)
c---- mother pointers to integer data
      integer   pMh             ! miller index
      integer   pMk             ! miller index
      integer   pMl             ! miller index
      integer   pMn             ! number of daughters
      integer   pMfirst         ! pointer to first daughter
      integer   pMIMAX          ! maximum integer pointer
      parameter (pMh=1)
      parameter (pMk=pMh+1)
      parameter (pMl=pMk+1)
      parameter (pMn=pMl+1)
      parameter (pMfirst=pMn+1)
      parameter (pMIMAX=pMfirst)
      integer   mI(pMIMAX,maxmother,hashbins) ! mother integer data
c---- mother pointers to real data
      integer   pMtheta         ! theta
      integer   pMangular       ! angular distribution
      integer   pMsum           ! summed intensity
      integer   pMmean          ! average intensity
      integer   pMmax           ! maximum intensity
      integer   pMmin           ! minimum intensity
      integer   pMRMAX          ! maximum real pointer
      parameter (pMtheta=1)
      parameter (pMangular=pMtheta+1)
      parameter (pMsum=pMangular+1)
      parameter (pMmean=pMsum+1)
      parameter (pMmax=pMmean+1)
      parameter (pMmin=pMmax+1)
      parameter (pMRMAX=pMmin)
      real      mR(pMRMAX,maxmother,hashbins) ! mother real data
      common /facelift_mother/ Nunique,nmother,mI,mR

      logical   facesavailable  !
      integer   nfaces          ! number of faces
      integer   nlist           ! number of faces in facelist
      real      mu              ! absorption coefficient
      integer   refineface1     ! pointer in facefactor array
      integer   refineface2     ! optional friedel pointer
      logical   faceactive(maxfaces) ! face active
      integer   facehkl(3,maxfaces) ! miller indices
      real      facexyz(3,maxfaces) ! laboratory vectors
      real      facedist(maxfaces) ! face distances
      real      facefactor(maxfaces) ! multiplication factors for face distance
      real      facesurface(maxfaces) ! surface
      integer   facesave(3,maxfaces) ! storage to save miller indices
      integer   facelist(maxfaces) ! list of selected faces
      common /facelift_faces/ facesavailable,nfaces,nlist,mu,
     +     refineface1,refineface2,faceactive,facehkl,facexyz,facedist,
     +     facefactor,facesurface,facesave,facelist

      integer   ncorners        ! number of corners
      real      cornerxyz(3,maxcorners) ! laboratory vectors
      logical   FaceCornerTable(maxfaces,maxcorners)
      common /facelift_corners/ ncorners,cornerxyz,FaceCornerTable

      integer   nedges          ! number of edges
      integer   edgecorner(2,maxedges) ! corner numbers of one edge
      integer   edgeface(2,maxedges) ! face numbers of one edge
      common /facelift_edges/ nedges,edgecorner,edgeface
      
      integer   nrotaxes        ! number of rotaxes
      real      rotaxes(3,maxrotaxes)
      common /facelift_rotax/ nrotaxes,rotaxes

      integer   nmatrices       ! number of matrices
      real      matrices(3,3,maxmatrices)
      common /facelift_matrix/ nmatrices,matrices

c---- cell parameters
      logical   myrmatavailable ! do we have a valid rmat
      real      myrmat(3,3)     ! reciprocal axes matrix
      real      mydmat(3,3)     ! direct axes matrix
      real      mydmatTrans(3,3) ! transformation matrix
      real      ax(3)           ! direct cell axes
      real      ang(3)          ! direct cell angles
      real      axstar(3)       ! reciprocal cell axes
      real      angstar(3)      ! reciprocal cell angles
      logical   cellcheck       ! true=check change of cell parameters
      real      cellaxes(3)     ! check new cell parameters with these axes
      real      cellangles(3)   ! check new cell parameter with these angles
c---- cone projection
      real      ang109
      real      cona
      real      coscona
      real      phifact
c---- filter
      integer   naccept         ! number of reflections passing the filter
      integer   ngroups         ! number of unique reflections passing the filter
      integer   nhklmin         ! minimum number of equivalent reflections
      real      thetamin        ! minimum theta
      real      intmin          ! minimum intensity
      real      angdistmax      ! maximum angular distribution
c---- R2
      real      weight1         ! weight used in R2
      real      weight2         ! weight used in R2
      real      initr           ! R2 before refinement
      real      bestr           ! best R2 after refinement
      logical   improved        ! refinement was succesfull
      logical   CentricShape    ! simulateneous refinement of friedel faces
      real      badr            ! value of invalid R2
      real      improve         ! R2 value change to flag improvement
c---- almost zero
      real      zeroDET         ! almost zero value of determinant
      real      zeroXYZ         ! almost zero value of laboratory vectors
      real      zeroDIST        ! almost zero value of distances
      real      zeroANG         ! almost zero value of angles
c---- refinement
      real      tol             ! simplex tolerance
      real      extreme         ! initial refinement shift
c---- orientation refinement
      real      phistart        ! start angle in orientation list
      real      phistop         ! end angle in orientation list
      real      delphi          ! angle increment in orientation list
      real      OrientSimplexAngle ! initial rotation angle
      real      angmin          ! minimum angle between two orientations
      real      rotax(3)        ! actual rotation axis
c---- tilt refinement
      integer   deltatilt       ! miller index change during tilt
      real      angmax          ! maximum angle between original and tilted orientation
c---- misc
      integer   out             ! output unit
      integer   log             ! logfile unit
      real      lambda          ! wavelength
      integer   npoint          ! pointgroup number
      logical   menu            ! true=interactive, false is via GUI
      logical   useablehklfile  ! hkl files contains direction cosines
      real      xtaldim(3)      ! xtal description in eval14 format
      real      xtalrot(3)      ! xtal orientation in eval14 format
      real      initdistance    ! initial face distance
      integer   highindex       ! increase miller indices
      common /facelift_misc/ myrmatavailable,myrmat,mydmat,
     +     mydmatTrans,ax,ang,axstar,angstar,cellcheck,cellaxes,
     +     cellangles,
     +     ang109,cona,coscona,phifact,
     +     naccept,ngroups,nhklmin,thetamin,intmin,angdistmax,
     +     weight1,weight2,initr,bestr,improved,CentricShape,badr,
     +     improve,
     +     zeroDET,zeroXYZ,zeroDIST,zeroANG,
     +     tol,extreme,
     +     phistart,phistop,delphi,OrientSimplexAngle,angmin,rotax,
     +     deltatilt,angmax,
     +     out,log,lambda,npoint,menu,useablehklfile,xtaldim,xtalrot,
     +     initdistance,highindex

      integer cFG
      integer cBG
      integer cCOSI
      integer cCOSO
      integer cCIRCLE
      integer cAXESFG
      integer cAXESBG
      integer cFACESFG
      integer cFACESBG
      integer cCVECTOR
      integer cMAX
      parameter (cFG=1)
      parameter (cBG=cFG+1)
      parameter (cCOSI=cBG+1)
      parameter (cCOSO=cCOSI+1)
      parameter (cCIRCLE=cCOSO+1)
      parameter (cAXESFG=cCIRCLE+1)
      parameter (cAXESBG=cAXESFG+1)
      parameter (cFACESFG=cAXESBG+1)
      parameter (cFACESBG=cFACESFG+1)
      parameter (cCVECTOR=cFACESBG+1)
      parameter (cMAX=cCVECTOR)

c---- colour names
      character colournames(cMAX)*40
      character colours(cMAX)*40
c---- misc
      character pointgroup*6
      character compound*80     ! project name
      character projmodes(maxmodes)*20 ! projection mode names
      character correctlabel*80 ! used to display intermediate results
      character subrname*80     ! subroutine name. Used in logfile
      character workfile*80     ! workfile name
      character correctionmethod*4 ! ABST or ABSG
      character rmatfile*80     ! filename of rmatrix
      character hklname(3)*1    ! 'h' 'k' 'l'
      character distype*1       ! distance refinement type 'P' 'S' 'N'
      common /facelift_char/ colournames,colours,pointgroup,compound,
     +     projmodes,correctlabel,subrname,workfile,correctionmethod,
     +     rmatfile,hklname,distype

      logical   windowexists    ! graphics is possible
      logical   graphics
      integer   col(cMAX)       ! colour values
      logical   newwindow
      integer   size
      integer   posx
      integer   posy
      integer   screenx
      integer   screeny
      integer   projectionmode
      integer   pointsize
      logical   vectorsync
      logical   newworld
      real      viewvec(3)
      real      viewrot
      real      viewpartial
      real      viewspeed
      logical   doplotcorner
      logical   doplotaxes
      logical   movie
      integer   WindowShape
      logical   vertical
      logical   doplotlab
      common /facelift_graphics/ windowexists,graphics,col,
     +     newwindow,size,posx,posy,screenx,screeny,
     +     projectionmode,pointsize,vectorsync,newworld,viewvec,
     +     viewrot,viewpartial,viewspeed,doplotcorner,doplotaxes,movie,
     +     WindowShape,vertical,doplotlab

      integer ShapeSmall
      integer ShapeBig
      integer ShapeMakeBig
      parameter (ShapeSmall=0)
      parameter (ShapeBig=2)
      parameter (ShapeMakeBig=1)

      logical DoDeactivate
      logical DoNotDeactivate
      logical ExtraOutput
      logical NoExtraOutput
      logical AddFriedel
      logical NoFriedel
      parameter (DoDeactivate=.true.)
      parameter (DoNotDeactivate=.false.)
      parameter (ExtraOutput=.true.)
      parameter (NoExtraOutput=.false.)
      parameter (AddFriedel=.true.)
      parameter (NoFriedel=.false.)
