      real function Atan2AJMD(sina_glob,cosa_glob)
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      real      sina_glob
      real      cosa_glob
      real      minimal
      parameter (minimal = 1.0E-30)
      real      sina
      real      cosa
      real      a
      sina = sina_glob
      cosa = cosa_glob
      if(ABS(cosa).lt.minimal) cosa = minimal
      a = atan(sina / cosa) ! note that only the RATIO sina/cosa matters
      IF(cosa.lt.0.0) then
        IF(a.gt.0.0) then
          a = a - Pi
        else
          a = a + Pi
        endif
      endif
      Atan2AJMD = a
      return
      end
      subroutine CheckRmat(nr,message,ier)
      integer   nr              ! input
      character message*(*)     ! output
      integer   ier             ! output
      integer maxnrmat
      parameter (maxnrmat=4)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=maxqvec**5)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer nrmat
      integer nrmatavailable
      real    pgaxisZero
      real    pganglezero
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,nrmat,nrmatavailable,pgAxisZero,pgAngleZero,
     +     rmatavailable
      character rmatbravais*1
      character bravais*1
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      integer qvsize(maxqvec)
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ nqvec,qvvector,qvorder,qvsize,nqvp,qvp,qvphkl
      integer activermat
      logical DoRmatTrans
      real    reducedrmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,
     +     reducedrmatlist,tmatlist,sigmacelllist,sigmavolumelist
      character rmatbravaislist(maxnrmat)*1
      character bravaislist(maxnrmat)*1
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer nqveclist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      integer qvsizelist(maxqvec,maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/nqveclist,qvvectorlist,qvorderlist,
     +     qvsizelist,nqvplist,qvplist,qvphkllist
      external  rmatxxx
      if(nr.lt.1.or.nr.gt.maxnrmat) then
        call str_2integer(nr,maxnrmat,
     +       'Matrix number (#) out of range (1-#)',message)
        ier = -1
        return
      endif
      if(.not.rmatavailable(nr)) then
        call str_integer(nr,'rmat # is not available',message)
        ier = 1
        return
      endif
      call str_integer(nr,'rmat # is available',message)
      if(nr.eq.activermat) then
        call str_string(message,'# and active',message)
      endif
      ier = 0
      return
      end                       ! CheckRmat
      subroutine CountRmat
      integer maxnrmat
      parameter (maxnrmat=4)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=maxqvec**5)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer nrmat
      integer nrmatavailable
      real    pgaxisZero
      real    pganglezero
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,nrmat,nrmatavailable,pgAxisZero,pgAngleZero,
     +     rmatavailable
      character rmatbravais*1
      character bravais*1
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      integer qvsize(maxqvec)
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ nqvec,qvvector,qvorder,qvsize,nqvp,qvp,qvphkl
      integer activermat
      logical DoRmatTrans
      real    reducedrmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,
     +     reducedrmatlist,tmatlist,sigmacelllist,sigmavolumelist
      character rmatbravaislist(maxnrmat)*1
      character bravaislist(maxnrmat)*1
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer nqveclist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      integer qvsizelist(maxqvec,maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/nqveclist,qvvectorlist,qvorderlist,
     +     qvsizelist,nqvplist,qvplist,qvphkllist
      integer i
      external  rmatxxx
      nrmatavailable = 0
      do i=1,maxnrmat
        if(rmatavailable(i)) then
          nrmatavailable = nrmatavailable + 1
          nrmat = i
        endif
      enddo
      return
      end                       ! CountRmat
      subroutine dmatpg(dm,axiszero,anglezero,pg)
      real      dm(3,3)
      real      axiszero
      real      anglezero
      character pg*(*)
      real      a(3)
      real      al(3)
      character string*80
      call celldim(dm,a,al)
      call GetPG(a,al,axiszero,anglezero,pg,string)
      return
      end                       ! Dmatpg
      subroutine GetPG(a,al,axiszero,anglezero,short,long)
      real      a(3)            ! input
      real      al(3)           ! input
      real      axiszero        ! input
      real      anglezero       ! input
      character short*(*)       ! output
      character long*(*)        ! output
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      logical   rectangle(3)
      integer   i
      do i=1,3
        rectangle(i) = (abs(PiOver2-al(i)).lt.anglezero)
      enddo
      if(rectangle(1).and.rectangle(2).and.
     +     abs(120.0/Grad-al(3)).lt.anglezero.and.
     +     abs(a(1)-a(2)).lt.axiszero) then
        Short = '6/m'
      else if(rectangle(1).and.rectangle(2).and.rectangle(3)) then
        if(abs(a(1)-a(2)).lt.axiszero) then
          if(abs(a(1)-a(3)).lt.axiszero) then
            Short = 'm3'
          else
            Short = '4/m'
          endif
        else
          Short = 'mmm'
        endif
      else if(rectangle(1).and.rectangle(3)) then
        short = '2/m'
      else if(rectangle(2).and.rectangle(3)) then
        short = '2/m11'
      else if(rectangle(1).and.rectangle(2)) then
        short = '112/m'
      else if(abs(al(1)-al(2)).lt.anglezero.and.
     +       abs(al(1)-al(3)).lt.anglezero.and.
     +       abs(a(1)-a(2)).lt.axiszero.and.
     +       abs(a(1)-a(3)).lt.axiszero) then
        short = 'Rl'
      else
        short = '-1'
      endif
      call PGString(short,long)
      return
      end                       ! GetPG
      subroutine initaxes
      integer GoniostatTypeKappa
      integer GoniostatTypeEuler
      integer GoniostatTypeUnknown
      parameter (GoniostatTypeKappa=1)
      parameter (GoniostatTypeEuler=2)
      parameter (GoniostatTypeUnknown=0)
      integer GoniostatType
      real x_axis(3),y_axis(3),z_axis(3)
      logical AxesInitDone
      common /common_axes/ AxesInitDone,GoniostatType,x_axis,y_axis,
     +     z_axis
      character xyz(3)*1
      character abc(3)*1
      character albega(3)*5
      character gonionames(3)*5
      common /common_axes_char/ xyz,abc,albega,gonionames
      data AxesInitDone /.false./
      if(AxesInitDone) return
      AxesInitDone = .true.
      xyz(1) = 'x'
      xyz(2) = 'y'
      xyz(3) = 'z'
      abc(1) = 'a'
      abc(2) = 'b'
      abc(3) = 'c'
      albega(1) = 'alpha'
      albega(2) = 'beta'
      albega(3) = 'gamma'
      gonionames(1) = 'Omega'
      gonionames(2) = 'Kappa'
      gonionames(3) = 'Phi'
      GoniostatType = GoniostatTypeKappa
      call build_vector(1.0,0.0,0.0,x_axis)
      call build_vector(0.0,1.0,0.0,y_axis)
      call build_vector(0.0,0.0,1.0,z_axis)
      return
      end                       ! initaxes
      block data lauexxx
      integer pgTricl1
      integer pgTricl2
      integer pgMono1
      integer pgMono2
      integer pgMono3
      integer pgOrtho1
      integer pgOrtho2
      integer pgOrtho3
      integer pgTetraL1
      integer pgTetraL2
      integer pgTetraL3
      integer pgTetraH1
      integer pgTetraH2
      integer pgTetraH3
      integer pgTetraH4
      integer pgTetraH5
      integer pgTrigoL1
      integer pgTrigoL2
      integer pgTrigoH1
      integer pgTrigoH2
      integer pgTrigoH3
      integer pgTrigoH4
      integer pgTrigoH5
      integer pgTrigoH6
      integer pgHexaL1
      integer pgHexaL2
      integer pgHexaL3
      integer pgHexaH1
      integer pgHexaH2
      integer pgHexaH3
      integer pgHexaH4
      integer pgRhombo1
      integer pgRhombo2
      integer pgRhombo3
      integer pgRhombo4
      integer pgRhombo5
      integer pgHexaH5
      integer pgCubicL1
      integer pgCubicL2
      integer pgCubicH1
      integer pgCubicH2
      integer pgCubicH3
      parameter (pgTricl1=1)
      parameter (pgTricl2=pgTricl1+1)
      parameter (pgMono1=pgTricl2+1)
      parameter (pgMono2=pgMono1+1)
      parameter (pgMono3=pgMono2+1)
      parameter (pgOrtho1=pgMono3+1)
      parameter (pgOrtho2=pgOrtho1+1)
      parameter (pgOrtho3=pgOrtho2+1)
      parameter (pgTetraL1=pgOrtho3+1)
      parameter (pgTetraL2=pgTetraL1+1)
      parameter (pgTetraL3=pgTetraL2+1)
      parameter (pgTetraH1=pgTetraL3+1)
      parameter (pgTetraH2=pgTetraH1+1)
      parameter (pgTetraH3=pgTetraH2+1)
      parameter (pgTetraH4=pgTetraH3+1)
      parameter (pgTetraH5=pgTetraH4+1)
      parameter (pgTrigoL1=pgTetraH5+1)
      parameter (pgTrigoL2=pgTrigoL1+1)
      parameter (pgTrigoH1=pgTrigoL2+1)
      parameter (pgTrigoH2=pgTrigoH1+1)
      parameter (pgTrigoH3=pgTrigoH2+1)
      parameter (pgTrigoH4=pgTrigoH3+1)
      parameter (pgTrigoH5=pgTrigoH4+1)
      parameter (pgTrigoH6=pgTrigoH5+1)
      parameter (pgHexaL1=pgTrigoH6+1)
      parameter (pgHexaL2=pgHexaL1+1)
      parameter (pgHexaL3=pgHexaL2+1)
      parameter (pgHexaH1=PgHexaL3+1)
      parameter (pgHexaH2=PgHexaH1+1)
      parameter (pgHexaH3=PgHexaH2+1)
      parameter (pgHexaH4=PgHexaH3+1)
      parameter (pgHexaH5=PgHexaH4+1)
      parameter (pgRhombo1=PgHexaH5+1)
      parameter (pgRhombo2=PgRhombo1+1)
      parameter (pgRhombo3=PgRhombo2+1)
      parameter (pgRhombo4=PgRhombo3+1)
      parameter (pgRhombo5=PgRhombo4+1)
      parameter (pgCubicL1=PgRhombo5+1)
      parameter (pgCubicL2=PgCubicL1+1)
      parameter (pgCubicH1=PgCubicL2+1)
      parameter (pgCubicH2=PgCubicH1+1)
      parameter (pgCubicH3=PgCubicH2+1)
      integer maxpg
      parameter (maxpg=pgCubicH3)
      integer pgTriclFirst
      integer pgTriclLast
      integer pgMonoFirst
      integer pgMonoLast
      integer pgOrthoFirst
      integer pgOrthoLast
      integer pgTetraLfirst
      integer pgTetraLlast
      integer pgTetraHfirst
      integer pgTetraHlast
      integer pgTrigoLfirst
      integer pgTrigoLlast
      integer pgTrigoHfirst
      integer pgTrigoHlast
      integer pgHexaLfirst
      integer pgHexaLlast
      integer pgHexaHfirst
      integer pgHexaHlast
      integer pgRhombofirst
      integer pgRhombolast
      integer pgCubicLfirst
      integer pgCubicLlast
      integer pgCubicHfirst
      integer pgCubicHlast
      parameter(pgTriclFirst=pgTricl1)
      parameter(pgTriclLast=pgTricl2)
      parameter(pgMonoFirst=pgMono1)
      parameter(pgMonoLast=pgMono3)
      parameter(pgOrthoFirst=pgOrtho1)
      parameter(pgOrthoLast=pgOrtho3)
      parameter(pgTetraLfirst=pgTetraL1)
      parameter(pgTetraLlast=pgTetraL3)
      parameter(pgTetraHfirst=pgTetraH1)
      parameter(pgTetraHlast=pgTetraH5)
      parameter(pgTrigoLfirst=pgTrigoL1)
      parameter(pgTrigoLlast=pgTrigoL2)
      parameter(pgTrigoHfirst=pgTrigoH1)
      parameter(pgTrigoHlast=pgTrigoH6)
      parameter(pgHexaLfirst=pgHexaL1)
      parameter(pgHexaLlast=pgHexaL3)
      parameter(pgHexaHfirst=pgHexaH1)
      parameter(pgHexaHlast=pgHexaH5)
      parameter(pgRhombofirst=pgRhombo1)
      parameter(pgRhombolast=pgRhombo5)
      parameter(pgCubicLfirst=pgCubicL1)
      parameter(pgCubicLlast=pgCubicL2)
      parameter(pgCubicHfirst=pgCubicH1)
      parameter(pgCubicHlast=pgCubicH3)
      integer npg
      integer pgMatrixList(3,3,49)
      common /common_symm/ npg,pgMatrixList
      character pgnames(maxpg)*5
      common /common_symm_char/ pgnames
      data pgnames /'1','-1',
     +     '2','m','2/m',
     +     '222','mm2','mmm',
     +     '4','-4','4/m','422','4mm','-42m','-4m2','4/mmm',
     +     '3','-3','312','321','31m','3m1','-31m','-3m1',
     +     '6','-6','6/m','622','6mm','-6m2','-62m','6/mmm',
     +     'R3','R-3','R32','R3m','R-3m',
     +     '23','m3','432','-43m','m3m'/
      end
      subroutine operator
      character c*1
      integer   iostat
      call str_flush
      call termline('Type return to continue >',c,iostat)
      if(iostat.ne.0) call exitfatal
      if(c.eq.'Q'.or.c.eq.'q') call exitfatal
      return
      end                       ! Operator
      subroutine pgLong(symbol,long)
      integer   symbol
      character long*(*)
      integer pgTricl1
      integer pgTricl2
      integer pgMono1
      integer pgMono2
      integer pgMono3
      integer pgOrtho1
      integer pgOrtho2
      integer pgOrtho3
      integer pgTetraL1
      integer pgTetraL2
      integer pgTetraL3
      integer pgTetraH1
      integer pgTetraH2
      integer pgTetraH3
      integer pgTetraH4
      integer pgTetraH5
      integer pgTrigoL1
      integer pgTrigoL2
      integer pgTrigoH1
      integer pgTrigoH2
      integer pgTrigoH3
      integer pgTrigoH4
      integer pgTrigoH5
      integer pgTrigoH6
      integer pgHexaL1
      integer pgHexaL2
      integer pgHexaL3
      integer pgHexaH1
      integer pgHexaH2
      integer pgHexaH3
      integer pgHexaH4
      integer pgRhombo1
      integer pgRhombo2
      integer pgRhombo3
      integer pgRhombo4
      integer pgRhombo5
      integer pgHexaH5
      integer pgCubicL1
      integer pgCubicL2
      integer pgCubicH1
      integer pgCubicH2
      integer pgCubicH3
      parameter (pgTricl1=1)
      parameter (pgTricl2=pgTricl1+1)
      parameter (pgMono1=pgTricl2+1)
      parameter (pgMono2=pgMono1+1)
      parameter (pgMono3=pgMono2+1)
      parameter (pgOrtho1=pgMono3+1)
      parameter (pgOrtho2=pgOrtho1+1)
      parameter (pgOrtho3=pgOrtho2+1)
      parameter (pgTetraL1=pgOrtho3+1)
      parameter (pgTetraL2=pgTetraL1+1)
      parameter (pgTetraL3=pgTetraL2+1)
      parameter (pgTetraH1=pgTetraL3+1)
      parameter (pgTetraH2=pgTetraH1+1)
      parameter (pgTetraH3=pgTetraH2+1)
      parameter (pgTetraH4=pgTetraH3+1)
      parameter (pgTetraH5=pgTetraH4+1)
      parameter (pgTrigoL1=pgTetraH5+1)
      parameter (pgTrigoL2=pgTrigoL1+1)
      parameter (pgTrigoH1=pgTrigoL2+1)
      parameter (pgTrigoH2=pgTrigoH1+1)
      parameter (pgTrigoH3=pgTrigoH2+1)
      parameter (pgTrigoH4=pgTrigoH3+1)
      parameter (pgTrigoH5=pgTrigoH4+1)
      parameter (pgTrigoH6=pgTrigoH5+1)
      parameter (pgHexaL1=pgTrigoH6+1)
      parameter (pgHexaL2=pgHexaL1+1)
      parameter (pgHexaL3=pgHexaL2+1)
      parameter (pgHexaH1=PgHexaL3+1)
      parameter (pgHexaH2=PgHexaH1+1)
      parameter (pgHexaH3=PgHexaH2+1)
      parameter (pgHexaH4=PgHexaH3+1)
      parameter (pgHexaH5=PgHexaH4+1)
      parameter (pgRhombo1=PgHexaH5+1)
      parameter (pgRhombo2=PgRhombo1+1)
      parameter (pgRhombo3=PgRhombo2+1)
      parameter (pgRhombo4=PgRhombo3+1)
      parameter (pgRhombo5=PgRhombo4+1)
      parameter (pgCubicL1=PgRhombo5+1)
      parameter (pgCubicL2=PgCubicL1+1)
      parameter (pgCubicH1=PgCubicL2+1)
      parameter (pgCubicH2=PgCubicH1+1)
      parameter (pgCubicH3=PgCubicH2+1)
      integer maxpg
      parameter (maxpg=pgCubicH3)
      integer pgTriclFirst
      integer pgTriclLast
      integer pgMonoFirst
      integer pgMonoLast
      integer pgOrthoFirst
      integer pgOrthoLast
      integer pgTetraLfirst
      integer pgTetraLlast
      integer pgTetraHfirst
      integer pgTetraHlast
      integer pgTrigoLfirst
      integer pgTrigoLlast
      integer pgTrigoHfirst
      integer pgTrigoHlast
      integer pgHexaLfirst
      integer pgHexaLlast
      integer pgHexaHfirst
      integer pgHexaHlast
      integer pgRhombofirst
      integer pgRhombolast
      integer pgCubicLfirst
      integer pgCubicLlast
      integer pgCubicHfirst
      integer pgCubicHlast
      parameter(pgTriclFirst=pgTricl1)
      parameter(pgTriclLast=pgTricl2)
      parameter(pgMonoFirst=pgMono1)
      parameter(pgMonoLast=pgMono3)
      parameter(pgOrthoFirst=pgOrtho1)
      parameter(pgOrthoLast=pgOrtho3)
      parameter(pgTetraLfirst=pgTetraL1)
      parameter(pgTetraLlast=pgTetraL3)
      parameter(pgTetraHfirst=pgTetraH1)
      parameter(pgTetraHlast=pgTetraH5)
      parameter(pgTrigoLfirst=pgTrigoL1)
      parameter(pgTrigoLlast=pgTrigoL2)
      parameter(pgTrigoHfirst=pgTrigoH1)
      parameter(pgTrigoHlast=pgTrigoH6)
      parameter(pgHexaLfirst=pgHexaL1)
      parameter(pgHexaLlast=pgHexaL3)
      parameter(pgHexaHfirst=pgHexaH1)
      parameter(pgHexaHlast=pgHexaH5)
      parameter(pgRhombofirst=pgRhombo1)
      parameter(pgRhombolast=pgRhombo5)
      parameter(pgCubicLfirst=pgCubicL1)
      parameter(pgCubicLlast=pgCubicL2)
      parameter(pgCubicHfirst=pgCubicH1)
      parameter(pgCubicHlast=pgCubicH3)
      integer npg
      integer pgMatrixList(3,3,49)
      common /common_symm/ npg,pgMatrixList
      character pgnames(maxpg)*5
      common /common_symm_char/ pgnames
      character string*30
      character short*5
      call pgShort(symbol,short)
      if(symbol.ge.pgTriclfirst.and.symbol.le.pgTricllast) then
        string = 'Triclinic'
      else if(symbol.ge.pgMonofirst.and.symbol.le.pgMonolast) then
        string = 'Monoclinic'
      else if(symbol.ge.pgOrthofirst.and.symbol.le.pgOrtholast) then
        string = 'Orthorhombic'
      else if(symbol.ge.pgTetraLfirst.and.symbol.le.pgTetraLLast) then
        string = 'Tetragonal low'
      else if(symbol.ge.pgTetraHfirst.and.symbol.le.pgTetraHlast) then
        string = 'Tetragonal high'
      else if(symbol.ge.pgTrigoLfirst.and.symbol.le.pgTrigoLlast) then
        string = 'Trigonal low'
      else if(symbol.ge.pgTrigoHfirst.and.symbol.le.pgTrigoHlast) then
        string = 'Trigonal high'
      else if(symbol.ge.pgHexaLfirst.and.symbol.le.pgHexaLlast) then
        string = 'Hexagonal low'
      else if(symbol.ge.pgHexaHfirst.and.symbol.le.pgHexaHlast) then
        string = 'hexagonal high'
      else if(symbol.ge.pgCubicLfirst.and.symbol.le.pgCubicLlast) then
        string = 'Cubic low'
      else if(symbol.ge.pgCubicHfirst.and.symbol.le.pgCubicHlast) then
        string = 'Cubic high'
      else
        string = 'unknown'
      endif
      call str_2string(string,short,'# (#)',long)
      return
      end                       ! PgLong
      subroutine PgShort(symbol,short)
      character short*(*)
      integer pgTricl1
      integer pgTricl2
      integer pgMono1
      integer pgMono2
      integer pgMono3
      integer pgOrtho1
      integer pgOrtho2
      integer pgOrtho3
      integer pgTetraL1
      integer pgTetraL2
      integer pgTetraL3
      integer pgTetraH1
      integer pgTetraH2
      integer pgTetraH3
      integer pgTetraH4
      integer pgTetraH5
      integer pgTrigoL1
      integer pgTrigoL2
      integer pgTrigoH1
      integer pgTrigoH2
      integer pgTrigoH3
      integer pgTrigoH4
      integer pgTrigoH5
      integer pgTrigoH6
      integer pgHexaL1
      integer pgHexaL2
      integer pgHexaL3
      integer pgHexaH1
      integer pgHexaH2
      integer pgHexaH3
      integer pgHexaH4
      integer pgRhombo1
      integer pgRhombo2
      integer pgRhombo3
      integer pgRhombo4
      integer pgRhombo5
      integer pgHexaH5
      integer pgCubicL1
      integer pgCubicL2
      integer pgCubicH1
      integer pgCubicH2
      integer pgCubicH3
      parameter (pgTricl1=1)
      parameter (pgTricl2=pgTricl1+1)
      parameter (pgMono1=pgTricl2+1)
      parameter (pgMono2=pgMono1+1)
      parameter (pgMono3=pgMono2+1)
      parameter (pgOrtho1=pgMono3+1)
      parameter (pgOrtho2=pgOrtho1+1)
      parameter (pgOrtho3=pgOrtho2+1)
      parameter (pgTetraL1=pgOrtho3+1)
      parameter (pgTetraL2=pgTetraL1+1)
      parameter (pgTetraL3=pgTetraL2+1)
      parameter (pgTetraH1=pgTetraL3+1)
      parameter (pgTetraH2=pgTetraH1+1)
      parameter (pgTetraH3=pgTetraH2+1)
      parameter (pgTetraH4=pgTetraH3+1)
      parameter (pgTetraH5=pgTetraH4+1)
      parameter (pgTrigoL1=pgTetraH5+1)
      parameter (pgTrigoL2=pgTrigoL1+1)
      parameter (pgTrigoH1=pgTrigoL2+1)
      parameter (pgTrigoH2=pgTrigoH1+1)
      parameter (pgTrigoH3=pgTrigoH2+1)
      parameter (pgTrigoH4=pgTrigoH3+1)
      parameter (pgTrigoH5=pgTrigoH4+1)
      parameter (pgTrigoH6=pgTrigoH5+1)
      parameter (pgHexaL1=pgTrigoH6+1)
      parameter (pgHexaL2=pgHexaL1+1)
      parameter (pgHexaL3=pgHexaL2+1)
      parameter (pgHexaH1=PgHexaL3+1)
      parameter (pgHexaH2=PgHexaH1+1)
      parameter (pgHexaH3=PgHexaH2+1)
      parameter (pgHexaH4=PgHexaH3+1)
      parameter (pgHexaH5=PgHexaH4+1)
      parameter (pgRhombo1=PgHexaH5+1)
      parameter (pgRhombo2=PgRhombo1+1)
      parameter (pgRhombo3=PgRhombo2+1)
      parameter (pgRhombo4=PgRhombo3+1)
      parameter (pgRhombo5=PgRhombo4+1)
      parameter (pgCubicL1=PgRhombo5+1)
      parameter (pgCubicL2=PgCubicL1+1)
      parameter (pgCubicH1=PgCubicL2+1)
      parameter (pgCubicH2=PgCubicH1+1)
      parameter (pgCubicH3=PgCubicH2+1)
      integer maxpg
      parameter (maxpg=pgCubicH3)
      integer pgTriclFirst
      integer pgTriclLast
      integer pgMonoFirst
      integer pgMonoLast
      integer pgOrthoFirst
      integer pgOrthoLast
      integer pgTetraLfirst
      integer pgTetraLlast
      integer pgTetraHfirst
      integer pgTetraHlast
      integer pgTrigoLfirst
      integer pgTrigoLlast
      integer pgTrigoHfirst
      integer pgTrigoHlast
      integer pgHexaLfirst
      integer pgHexaLlast
      integer pgHexaHfirst
      integer pgHexaHlast
      integer pgRhombofirst
      integer pgRhombolast
      integer pgCubicLfirst
      integer pgCubicLlast
      integer pgCubicHfirst
      integer pgCubicHlast
      parameter(pgTriclFirst=pgTricl1)
      parameter(pgTriclLast=pgTricl2)
      parameter(pgMonoFirst=pgMono1)
      parameter(pgMonoLast=pgMono3)
      parameter(pgOrthoFirst=pgOrtho1)
      parameter(pgOrthoLast=pgOrtho3)
      parameter(pgTetraLfirst=pgTetraL1)
      parameter(pgTetraLlast=pgTetraL3)
      parameter(pgTetraHfirst=pgTetraH1)
      parameter(pgTetraHlast=pgTetraH5)
      parameter(pgTrigoLfirst=pgTrigoL1)
      parameter(pgTrigoLlast=pgTrigoL2)
      parameter(pgTrigoHfirst=pgTrigoH1)
      parameter(pgTrigoHlast=pgTrigoH6)
      parameter(pgHexaLfirst=pgHexaL1)
      parameter(pgHexaLlast=pgHexaL3)
      parameter(pgHexaHfirst=pgHexaH1)
      parameter(pgHexaHlast=pgHexaH5)
      parameter(pgRhombofirst=pgRhombo1)
      parameter(pgRhombolast=pgRhombo5)
      parameter(pgCubicLfirst=pgCubicL1)
      parameter(pgCubicLlast=pgCubicL2)
      parameter(pgCubicHfirst=pgCubicH1)
      parameter(pgCubicHlast=pgCubicH3)
      integer npg
      integer pgMatrixList(3,3,49)
      common /common_symm/ npg,pgMatrixList
      character pgnames(maxpg)*5
      common /common_symm_char/ pgnames
      external lauexxx
      integer symbol
      if(symbol.ge.1.and.symbol.le.maxpg) then
        short = pgnames(symbol)
      else
        short = '?'
      endif
      return
      end                       ! PgShort
      subroutine PgString(short,long)
      character short*(*)
      character long*(*)
      integer   symbol
      call PgSymbol(short,symbol)
      call PgLong(symbol,long)
      return
      end                       ! PgString
      subroutine PgSymbol(inputpg,symbol)
      character inputpg*(*)
      integer   symbol
      integer pgTricl1
      integer pgTricl2
      integer pgMono1
      integer pgMono2
      integer pgMono3
      integer pgOrtho1
      integer pgOrtho2
      integer pgOrtho3
      integer pgTetraL1
      integer pgTetraL2
      integer pgTetraL3
      integer pgTetraH1
      integer pgTetraH2
      integer pgTetraH3
      integer pgTetraH4
      integer pgTetraH5
      integer pgTrigoL1
      integer pgTrigoL2
      integer pgTrigoH1
      integer pgTrigoH2
      integer pgTrigoH3
      integer pgTrigoH4
      integer pgTrigoH5
      integer pgTrigoH6
      integer pgHexaL1
      integer pgHexaL2
      integer pgHexaL3
      integer pgHexaH1
      integer pgHexaH2
      integer pgHexaH3
      integer pgHexaH4
      integer pgRhombo1
      integer pgRhombo2
      integer pgRhombo3
      integer pgRhombo4
      integer pgRhombo5
      integer pgHexaH5
      integer pgCubicL1
      integer pgCubicL2
      integer pgCubicH1
      integer pgCubicH2
      integer pgCubicH3
      parameter (pgTricl1=1)
      parameter (pgTricl2=pgTricl1+1)
      parameter (pgMono1=pgTricl2+1)
      parameter (pgMono2=pgMono1+1)
      parameter (pgMono3=pgMono2+1)
      parameter (pgOrtho1=pgMono3+1)
      parameter (pgOrtho2=pgOrtho1+1)
      parameter (pgOrtho3=pgOrtho2+1)
      parameter (pgTetraL1=pgOrtho3+1)
      parameter (pgTetraL2=pgTetraL1+1)
      parameter (pgTetraL3=pgTetraL2+1)
      parameter (pgTetraH1=pgTetraL3+1)
      parameter (pgTetraH2=pgTetraH1+1)
      parameter (pgTetraH3=pgTetraH2+1)
      parameter (pgTetraH4=pgTetraH3+1)
      parameter (pgTetraH5=pgTetraH4+1)
      parameter (pgTrigoL1=pgTetraH5+1)
      parameter (pgTrigoL2=pgTrigoL1+1)
      parameter (pgTrigoH1=pgTrigoL2+1)
      parameter (pgTrigoH2=pgTrigoH1+1)
      parameter (pgTrigoH3=pgTrigoH2+1)
      parameter (pgTrigoH4=pgTrigoH3+1)
      parameter (pgTrigoH5=pgTrigoH4+1)
      parameter (pgTrigoH6=pgTrigoH5+1)
      parameter (pgHexaL1=pgTrigoH6+1)
      parameter (pgHexaL2=pgHexaL1+1)
      parameter (pgHexaL3=pgHexaL2+1)
      parameter (pgHexaH1=PgHexaL3+1)
      parameter (pgHexaH2=PgHexaH1+1)
      parameter (pgHexaH3=PgHexaH2+1)
      parameter (pgHexaH4=PgHexaH3+1)
      parameter (pgHexaH5=PgHexaH4+1)
      parameter (pgRhombo1=PgHexaH5+1)
      parameter (pgRhombo2=PgRhombo1+1)
      parameter (pgRhombo3=PgRhombo2+1)
      parameter (pgRhombo4=PgRhombo3+1)
      parameter (pgRhombo5=PgRhombo4+1)
      parameter (pgCubicL1=PgRhombo5+1)
      parameter (pgCubicL2=PgCubicL1+1)
      parameter (pgCubicH1=PgCubicL2+1)
      parameter (pgCubicH2=PgCubicH1+1)
      parameter (pgCubicH3=PgCubicH2+1)
      integer maxpg
      parameter (maxpg=pgCubicH3)
      integer pgTriclFirst
      integer pgTriclLast
      integer pgMonoFirst
      integer pgMonoLast
      integer pgOrthoFirst
      integer pgOrthoLast
      integer pgTetraLfirst
      integer pgTetraLlast
      integer pgTetraHfirst
      integer pgTetraHlast
      integer pgTrigoLfirst
      integer pgTrigoLlast
      integer pgTrigoHfirst
      integer pgTrigoHlast
      integer pgHexaLfirst
      integer pgHexaLlast
      integer pgHexaHfirst
      integer pgHexaHlast
      integer pgRhombofirst
      integer pgRhombolast
      integer pgCubicLfirst
      integer pgCubicLlast
      integer pgCubicHfirst
      integer pgCubicHlast
      parameter(pgTriclFirst=pgTricl1)
      parameter(pgTriclLast=pgTricl2)
      parameter(pgMonoFirst=pgMono1)
      parameter(pgMonoLast=pgMono3)
      parameter(pgOrthoFirst=pgOrtho1)
      parameter(pgOrthoLast=pgOrtho3)
      parameter(pgTetraLfirst=pgTetraL1)
      parameter(pgTetraLlast=pgTetraL3)
      parameter(pgTetraHfirst=pgTetraH1)
      parameter(pgTetraHlast=pgTetraH5)
      parameter(pgTrigoLfirst=pgTrigoL1)
      parameter(pgTrigoLlast=pgTrigoL2)
      parameter(pgTrigoHfirst=pgTrigoH1)
      parameter(pgTrigoHlast=pgTrigoH6)
      parameter(pgHexaLfirst=pgHexaL1)
      parameter(pgHexaLlast=pgHexaL3)
      parameter(pgHexaHfirst=pgHexaH1)
      parameter(pgHexaHlast=pgHexaH5)
      parameter(pgRhombofirst=pgRhombo1)
      parameter(pgRhombolast=pgRhombo5)
      parameter(pgCubicLfirst=pgCubicL1)
      parameter(pgCubicLlast=pgCubicL2)
      parameter(pgCubicHfirst=pgCubicH1)
      parameter(pgCubicHlast=pgCubicH3)
      integer npg
      integer pgMatrixList(3,3,49)
      common /common_symm/ npg,pgMatrixList
      character pgnames(maxpg)*5
      common /common_symm_char/ pgnames
      external lauexxx
      integer i
      character pg*5
      pg = inputpg
      do i=1,maxpg
        if(pg.eq.pgnames(i)) then
          symbol = i
          return
        endif
      enddo
      if(pg.eq.'Mb'.or.pg.eq.'M') then
        symbol = pgMonolast
      else if(pg.eq.'O') then
        symbol = pgOrtholast
      else if(pg.eq.'Tl'.or.pg.eq.'T') then
        symbol = pgTetraLlast
      else if(pg.eq.'Th') then
        symbol = pgTetraHlast
      else if(pg.eq.'Hl'.or.pg.eq.'H') then
        symbol = pgHexaLlast
      else if(pg.eq.'Hh') then
        symbol = pgHexaHlast
      else if(pg.eq.'Cl'.or.pg.eq.'C') then
        symbol = pgCubicLlast
      else if(pg.eq.'Ch') then
        symbol = pgCubicHlast
      else
        symbol = 0
      endif
      return
      end ! PgSymbol
      subroutine QVbuild
      integer maxnrmat
      parameter (maxnrmat=4)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=maxqvec**5)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer nrmat
      integer nrmatavailable
      real    pgaxisZero
      real    pganglezero
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,nrmat,nrmatavailable,pgAxisZero,pgAngleZero,
     +     rmatavailable
      character rmatbravais*1
      character bravais*1
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      integer qvsize(maxqvec)
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ nqvec,qvvector,qvorder,qvsize,nqvp,qvp,qvphkl
      external  rmatxxx
      integer i
      integer j
      integer k
      integer p
      integer column
      integer size1
      integer size2
      real    hkl(3)
      real    v(3)
      if(nqvec.lt.1) return
      qvsize(1) = 1 + 2*qvorder(1)
      do i=2,nqvec
        qvsize(i) = qvsize(i-1) * (1+2*qvorder(i))
      enddo
      nqvp = qvsize(nqvec)
      do column=1,nqvec
        if(column.gt.1) then
          size1 = qvsize(column-1)
        else
          size1 = 1
        endif
        if(column.lt.nqvec) then
          size2 = 1+2*qvorder(column+1)
          do i=column+2,nqvec
            size2 = size2 * (1+2*qvorder(i))
          enddo
        else
          size2 = 1
        endif
        p = 0
        do j=1,size2
          do i=-qvorder(column),qvorder(column)
            do k=1,size1
              p = p + 1
              qvp(column,p) = i
            enddo
          enddo
        enddo
      enddo
      do i=1,nqvp
        call getvec(qvvector,1,v)
        call facvec(float(qvp(1,i)),v,hkl)
        do j=2,nqvec
          call GetVec(qvvector,j,v)
          call facvec(float(qvp(j,i)),v,v)
          call sumvec(hkl,v,hkl)
        enddo
        call savevec(hkl,qvphkl,i)
      enddo
      return
      end                       ! QVBuild
      subroutine ReadRmatList(rmatfilename,nr,message,ier)
      character rmatfilename*(*) ! input
      integer   nr              ! input
      character message*(*)     ! output
      integer   ier             ! output
      integer maxnrmat
      parameter (maxnrmat=4)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=maxqvec**5)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer nrmat
      integer nrmatavailable
      real    pgaxisZero
      real    pganglezero
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,nrmat,nrmatavailable,pgAxisZero,pgAngleZero,
     +     rmatavailable
      character rmatbravais*1
      character bravais*1
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      integer qvsize(maxqvec)
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ nqvec,qvvector,qvorder,qvsize,nqvp,qvp,qvphkl
      integer activermat
      logical DoRmatTrans
      real    reducedrmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,
     +     reducedrmatlist,tmatlist,sigmacelllist,sigmavolumelist
      character rmatbravaislist(maxnrmat)*1
      character bravaislist(maxnrmat)*1
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer nqveclist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      integer qvsizelist(maxqvec,maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/nqveclist,qvvectorlist,qvorderlist,
     +     qvsizelist,nqvplist,qvplist,qvphkllist
      external  rmatxxx
      integer   length
      integer   unit
      integer   i,j
      character line*80
      character uline*80
      character filename*80
      integer   lf
      integer   nline
      logical   rmatfound
      call CheckRmat(nr,message,ier)
      if(ier.lt.0) return
      rmatavailable(nr) = .false.
      rmatfound = .false.
      call unit_matrix(rmat)
      call unit_matrix(reducedrmat)
      call unit_matrix(tmat)
      rmatbravais = 'P'
      bravais = 'P'
      pg = ' '
      nqvec = 0
      nqvp = 0
      do i=1,6
        SigmaCell(i) = -1.0
      enddo
      sigmavolume = -1.0
      call unit_matrix(tmat)
      filename = rmatfilename
      call open_file(filename,unit,message,ier)
      if(ier.ne.0) then
        call build_file(filename,' ','.rmat',filename,lf)
        call open_file(filename,unit,message,ier)
        if(ier.ne.0) return
      endif
      nline = 0
      read(unit,100,iostat=ier) line
  100 format(a)
      do while(ier.eq.0)
        nline = nline + 1
        call upcase(line,uline)
        if(uline(1:4).eq.'RMAT') then
          call str_leading(line(6:),line)
          rmatbravais = line(1:1)
          if(rmatbravais.eq.' ') rmatbravais = 'P'
          bravais = rmatbravais
          read(unit,*,iostat=ier) ((reducedrmat(i,j),j=1,3),i=1,3)
          if(ier.ne.0) then
            message = 'Error # after line # reading Rmatrix from #'
            call str_integer(ier,message,message)
            call str_integer(nline,message,message)
            call str_string(filename,message,message)
            close(unit)
            return
          endif
          nline = nline + 3
          rmatfound = .true.
        else if(uline(1:5).eq.'SIGMA') then
          call str_leading(line(7:),line)
          read(line,*,iostat=ier) sigmacell,sigmavolume
        else if(uline(1:4).eq.'TMAT') then
          call str_extract(line,2,bravais)
          call str_extract(line,3,pg)
          if(bravais.eq.' ') bravais = 'P'
          read(unit,*,iostat=ier) ((tmat(i,j),j=1,3),i=1,3)
          if(ier.ne.0) then
            message = 'Error # after line # reading Tmatrix from #'
            call str_integer(ier,message,message)
            call str_integer(nline,message,message)
            call str_string(filename,message,message)
            close(unit)
            return
          endif
          nline = nline + 3
        else if(line(1:1).eq.'#') then
          continue
        else if(line(1:5).eq.'QVEC ') then
          if(nqvec.ge.maxqvec) then
            call str_integer(maxqvec,'Too many qvectors. Maximum=#',
     +           message)
            ier = 1
            return
          endif
          nqvec = nqvec + 1
          read(line(6:),*,iostat=ier) (qvvector(i,nqvec),i=1,3),
     +         qvorder(nqvec)
          if(ier.ne.0) then
            message = 'Error # after line # reading QVEC #'
            call str_integer(ier,message,message)
            call str_integer(nline,message,message)
            call str_string(filename,message,message)
            close(unit)
            return
          endif
        else if(length(line).gt.0) then
          message = 'Unexpected data on line # of #: #'
          call str_integer(nline,message,message)
          call str_string(filename,message,message)
          call str_string(line,message,message)
          close(unit)
          ier = 1
          return
        endif
        read(unit,100,iostat=ier) line
      enddo
      close(unit)
      ier = 0
      if(.not.rmatfound) then
        message = 'No rmatrix found in file #'
        call str_string(filename,message,message)
        ier = 1
        goto 900
      endif
      rmattitle = rmatfilename
      call SaveRmat(nr,message,ier)
      if(ier.ne.0) goto 900
      call str_string(filename,'Cell from #',message)
      ier = 0
  900 continue
      if(ier.ne.0) then
        rmatavailable(nr) = .false.
      else
        rmatavailable(nr) = .true.
      endif
      call CountRmat
      return
      end                       ! readrmatList
      block data rmatxxx
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer maxnrmat
      parameter (maxnrmat=4)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=maxqvec**5)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer nrmat
      integer nrmatavailable
      real    pgaxisZero
      real    pganglezero
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,nrmat,nrmatavailable,pgAxisZero,pgAngleZero,
     +     rmatavailable
      character rmatbravais*1
      character bravais*1
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      integer qvsize(maxqvec)
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ nqvec,qvvector,qvorder,qvsize,nqvp,qvp,qvphkl
      integer activermat
      logical DoRmatTrans
      real    reducedrmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,
     +     reducedrmatlist,tmatlist,sigmacelllist,sigmavolumelist
      character rmatbravaislist(maxnrmat)*1
      character bravaislist(maxnrmat)*1
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer nqveclist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      integer qvsizelist(maxqvec,maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/nqveclist,qvvectorlist,qvorderlist,
     +     qvsizelist,nqvplist,qvplist,qvphkllist
      real an0
      parameter (an0 = 0.1/grad)
      data rmatavailable /maxnrmat*.false./
      data nrmat,activermat /0,0/
      data DoRmatTrans /.true./
      data pgAxisZero /0.1/
      data pgAngleZero /an0/
      end ! block data rmatxxx
      subroutine SaveRmat(nr,message,ier)
      integer   nr              ! input
      character message*(*)     ! output
      integer   ier             ! output
      integer maxnrmat
      parameter (maxnrmat=4)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=maxqvec**5)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer nrmat
      integer nrmatavailable
      real    pgaxisZero
      real    pganglezero
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,nrmat,nrmatavailable,pgAxisZero,pgAngleZero,
     +     rmatavailable
      character rmatbravais*1
      character bravais*1
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      integer qvsize(maxqvec)
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ nqvec,qvvector,qvorder,qvsize,nqvp,qvp,qvphkl
      integer activermat
      logical DoRmatTrans
      real    reducedrmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,
     +     reducedrmatlist,tmatlist,sigmacelllist,sigmavolumelist
      character rmatbravaislist(maxnrmat)*1
      character bravaislist(maxnrmat)*1
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer nqveclist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      integer qvsizelist(maxqvec,maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/nqveclist,qvvectorlist,qvorderlist,
     +     qvsizelist,nqvplist,qvplist,qvphkllist
      external  rmatxxx
      integer i
      integer j
      call CheckRmat(nr,message,ier)
      if(ier.lt.0) return
      call savemat(reducedrmat,reducedrmatlist,nr)
      call savemat(tmat,tmatlist,nr)
      do i=1,6
        sigmacelllist(i,nr) = sigmacell(i)
      enddo
      sigmavolumelist(nr) = sigmavolume
      rmattitlelist(nr) = rmattitle
      if(nqvec.gt.0) call QVbuild
      nqveclist(nr) = nqvec
      do i=1,nqvec
        do j=1,3
          qvvectorlist(j,i,nr) = qvvector(j,i)
        enddo
        qvorderlist(i,nr) = qvorder(i)
        qvsizelist(i,nr) = qvsize(i)
      enddo
      nqvplist(nr) = nqvp
      do i=1,nqvp
        do j=1,nqvec
          qvplist(j,i,nr) = qvp(j,i)
        enddo
        do j=1,3
          qvphkllist(j,i,nr) = qvphkl(j,i)
        enddo
      enddo
      rmatbravaislist(nr) = rmatbravais
      bravaislist(nr) = bravais
      call invertmat(reducedrmat,dmat,ier)
      if(ier.ne.0) then
        message = 'Cannot invert reduced rmat'
        return
      endif
      if(DoRmatTrans) then
        call MatMat(tmat,dmat,dmat)
        call invertmat(dmat,rmat,ier)
        if(ier.ne.0) then
          message = 'Cannot invert tmat*dmat'
          return
        endif
      else
        call copymat(reducedrmat,rmat)
      endif
      if(pg.eq.' ') then
        call dmatpg(dmat,pgAxisZero,pgAngleZero,pg)
      endif
      pglist(nr) = pg
      rmatavailable(nr) = .true.
      ier = 0
      activermat = nr
      call str_integer(nr,'Saved current rmat as #',message)
      call CountRmat
      return
      end                       ! SaveRmat
